/*
 * pref_check.c
 * Copyright (C) 2010 - 2013 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "prefs.h"
#include <commctrl.h>

static prefvmt_t vmt;

prefgui_t *prefs_check(prefgui_t *pg, prefdef_t *pd, prefs_t *ps, HWND hDlg)
{
  pg->vmt=&vmt;
  pg->pd=pd;
  pg->id=pd->id;

  vmt.set(pg,ps,hDlg);

  return pg;
}

static void set(prefgui_t *pg, prefs_t *ps, HWND hDlg)
{
  prefdef_t *pd=pg->pd;
#if 0 && defined (DEBUG) // [
  int i;
#endif // ]

//DMARKLN();
//DVWRITELN("hDlg: %p, id: %d, offs: %d, ps: %p",hDlg,pg->id,pd->offs,ps);
#if 0 && defined (DEBUG) // [
i=pref_int(pd,ps);
DVWRITELN("pref_int(pd,ps): %d",i);
#endif // ]
//DMARKLN();
  CheckDlgButton(hDlg,pg->id,PREF_INT==pd->type?0!=pref_int(pd,ps):0);
//DMARKLN();
}

static void get(prefgui_t *pg, prefs_t *ps, HWND hDlg)
{
  prefdef_t *pd=pg->pd;

  if (PREF_INT==pd->type)
    pref_int(pd,ps)=IsDlgButtonChecked(hDlg,pg->id)?1:0;
}

static int get_int(prefgui_t *pg, HWND hDlg)
{
  prefdef_t *pd=pg->pd;

  return PREF_INT==pd->type?(IsDlgButtonChecked(hDlg,pg->id)?1:0):0;
}

static double get_double(prefgui_t *pg, HWND hDlg)
{
  return 0.0;
}

static prefvmt_t vmt={
  .set=set,
  .get=get,
  .get_int=get_int,
  .get_double=get_double
};
