/*
 * prefs_enablethemedialogtexture.c
 * Copyright (C) 2010 - 2013 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include <windows.h>
#include <commctrl.h>
#include <uxtheme.h>
#include "plugin.h"

// http://forums.winamp.com/showthread.php?t=199333
HRESULT PrefsEnableThemeDialogTexture(HWND hWnd, DWORD dwFlags)
{
#if defined (ENABLE_THEME_DIALOG_TEXTURE_INDIRECT) // [
  typedef HRESULT (*etdt_t)(HWND hwnd, DWORD dwFlags);

#if 0 // [
  HRESULT hRes=NULL;
#else // ] [
  HRESULT hRes=(HRESULT)NULL;
#endif // ]
  HANDLE hDll=NULL;
  etdt_t etdt=NULL;

  if (NULL==(hDll=LoadLibraryA("uxtheme.dll")))
    goto cleanup_hdll;

  if (NULL==(etdt=(etdt_t)GetProcAddress(hDll,"EnableThemeDialogTexture")))
    goto cleanup_etdt;

  hRes=etdt(hWnd,dwFlags);
cleanup_etdt:
  FreeLibrary(hDll);
cleanup_hdll:
  return hRes;
#else // ] [
  return EnableThemeDialogTexture(
    hWnd,     // _In_ HWND  hwnd,
    dwFlags   // _In_ DWORD dwFlags
  );
#endif // ]
}
