/*
 * yas_api.h
 *
 * Yet Another Shuffle for Winamp (gen_yas)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * gen_yas is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * gen_yas is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with gen_yas.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __YAS_API_H__ // [
#define __YAS_API_H__
#ifdef __cplusplus // [
extern "C" {
#endif // ]

///////////////////////////////////////////////////////////////////////////////
#if defined (YAS_EXPORT) // [
#undef YAS_EXPORT
#define YAS_EXPORT __declspec (dllexport)
#else // ] [
#define YAS_EXPORT __declspec (dllimport)
#endif // ]

///////////////////////////////////////////////////////////////////////////////
typedef enum _YasApiVersion YasApiVersion;
typedef struct _YasApi YasApi;
typedef const YasApi *(GetYasApiFun)(void);

///////////////////////////////////////////////////////////////////////////////
enum _YasApiVersion {
  eYasApiVersion=1
};

///////////////////////////////////////////////////////////////////////////////
struct _YasApi {
  // available with version 1 of the api:
  const int nVersion;
  const char *(*NextA)(void);
  const wchar_t *(*NextW)(void);
  // available with version 2 of the api:
};

///////////////////////////////////////////////////////////////////////////////
YAS_EXPORT GetYasApiFun GetYasApi;

#ifdef __cplusplus // [
}
#endif // ]
#endif // __YAS_API_H__ ]
