/*
 * ffsox_rep.h
 * Copyright (C) 2010, 2012 Peter Belkner <pbelkner@snafu.de>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef __FFSOX_REP_H__
#define __FFSOX_REP_H__

#include "ffsox.h"

///////////////////////////////////////////////////////////////////////////////
typedef struct ffsox_rep {
  size_t size;
  uint8_t *buf;
} ffsox_rep_t;

ffsox_rep_t *ffsox_rep_init(ffsox_rep_t *r);
ffsox_rep_t *ffsox_rep_cleanup(ffsox_rep_t *r);

#define FFSOX_REP_I2P(T,r,frame,nch,error) do { \
  int nb_samples=(frame)->nb_samples; \
  T *rp=(T *)(frame)->data[0]; \
  T *mp=rp+(nch)*nb_samples; \
  T *wp; \
  int size=(nch)*nb_samples*sizeof *wp; \
  int i; \
 \
  if (0==(r)->size) { \
    if (NULL==((r)->buf=malloc(size))) \
      goto error; \
 \
    (r)->size=size; \
  } \
  else if ((r)->size<size) { \
    if (NULL==(buf=realloc((r)->buf,size))) \
      goto error; \
 \
    (r)->buf=buf; \
    (r)->size=size; \
  } \
 \
  wp=(T *)(r)->buf; \
 \
  while (rp<mp) { \
	for (i=0;i<(nch);++i) \
	  wp[i*nb_samples]=*rp++; \
 \
    ++wp; \
  } \
} while (0)

#endif // __FFSOX_REP_H__
