#include <stdarg.h>
#include "pb_xy.h"

static void pb_a_set_offs(pb_a_t *a)
{
  a->offs1=(a->n+1)*sizeof *a->psp;
  a->offs2=a->offs1+a->n*sizeof **a->psp;
}

void pb_a_start(pb_a_t *a, pb_str_t **psp)
{
  a->psp=psp;
  a->ps=psp?(pb_str_t *)((char *)psp+a->offs1):NULL;
  a->buf=psp?(char *)psp+a->offs2:NULL;

  if (NULL!=psp)
    pb_a_set_offs(a);

  a->n=0;
  pb_z_init(&a->z,a->buf);
}

void pb_a_add(pb_a_t *a, TCHAR *s)
{
  pb_z_assign(&a->z,a->buf,a->psp?a->psp[a->n]=a->ps+a->n:NULL);
  pb_z_part(&a->z,s,a->buf);
  pb_z_whole(&a->z,a->buf);
  ++a->n;
}

void pb_a_add_v(pb_a_t *a, TCHAR *s, ...)
{
  va_list ap;

  pb_z_assign(&a->z,a->buf,a->psp?a->psp[a->n]=a->ps+a->n:NULL);
  va_start(ap,s);

  for (;s;s=va_arg(ap,TCHAR *))
    pb_z_part(&a->z,s,a->buf);

  va_end(ap);
  pb_z_whole(&a->z,a->buf);
  ++a->n;
}

void pb_a_add_ps(pb_a_t *a, pb_str_t *s)
{
  pb_z_assign(&a->z,a->buf,a->psp?a->psp[a->n]=a->ps+a->n:NULL);
  pb_z_part_ps(&a->z,s,a->buf);
  pb_z_whole(&a->z,a->buf);
  ++a->n;
}

int pb_a_finish(pb_a_t *a)
{
  if (NULL==a->psp)
    pb_a_set_offs(a);
  else
	a->psp[a->n]=NULL;

  return a->offs2+pb_z_size(&a->z);
}

int pb_a_str_cre_n(pb_a_t *a, TCHAR **s, int n, pb_str_t **psp)
{
  int i;

  pb_a_start(a,psp);

  for (i=0;i<n;++i)
    pb_a_add(a,s[i]);

  return pb_a_finish(a);
}

int pb_a_str_cre_n_ps(pb_a_t *a, pb_str_t **s, int n, pb_str_t **psp)
{
  int i;

  pb_a_start(a,psp);

  for (i=0;i<n;++i)
    pb_a_add_ps(a,s[i]);

  return pb_a_finish(a);
}

int pb_a_str_cre_v(pb_a_t *a, TCHAR **s, pb_str_t **psp)
{
  pb_a_start(a,psp);

  while (*s)
    pb_a_add(a,*s++);

  return pb_a_finish(a);
}

int pb_a_str_cre_v_ps(pb_a_t *a, pb_str_t **s, pb_str_t **psp)
{
  pb_a_start(a,psp);

  while (*s)
    pb_a_add_ps(a,*s++);

  return pb_a_finish(a);
}
