#include <stdlib.h>
#include <string.h>
#include "pb_xy.h"

static void atom(char *s, char sep, int *size, char *buf)
{
  int n=strlen(s);

  if (NULL!=buf) {
    memcpy(buf+*size,s,n);
    (buf+*size)[n]=sep;
    (buf+*size)[n+1]=0;
  }

  *size+=n+1;
}

#if defined (WIN32) && defined (UNICODE)
static void watom(wchar_t *ws, wchar_t sep, int *size, char *buf)
{
  int n=wcslen(ws);

  if (NULL!=buf) {
    memcpy(buf+*size,ws,n*sizeof(TCHAR));
    ((TCHAR *)(buf+*size))[n]=sep;
    ((TCHAR *)(buf+*size))[n+1]=0;
  }

  *size+=(n+1)*sizeof(TCHAR);
}
#endif

static int loop(pb_path_t *p, pb_path_t *tail,pb_str_t *file)
{
  int size=sizeof *p;
  char *buf=(char *)p;

  if (NULL!=p) {
    p->prev=NULL;
    p->path=(pb_str_t *)(buf+size);
  }

  size+=sizeof *p->path;

#if defined (WIN32) && defined (UNICODE)
  // tcs
  if (NULL!=p)
    p->path->tcs=(TCHAR *)(buf+size);

  if (NULL!=tail)
    watom(tail->path->tcs,L'\\',&size,buf);

  watom(file->tcs,0,&size,buf);

  // utf8
  if (NULL!=p)
    p->path->utf8=buf+size;

  if (NULL!=tail)
    atom(tail->path->utf8,'\\',&size,buf);

  atom(file->utf8,0,&size,buf);

  // oem
  if (NULL!=p)
    p->path->oem=buf+size;

  if (NULL!=tail)
    atom(tail->path->oem,'\\',&size,buf);

  atom(file->oem,0,&size,buf);
#else
  // utf8
  if (NULL!=p) {
    p->path->utf8=buf+size;
    p->path->oem=buf+size;
#if defined (WIN32)
    p->path->tcs=buf+size;
#endif
  }

  if (NULL!=tail)
#if defined (WIN32)
    atom(tail->path->utf8,'\\',&size,buf);
#else
    atom(tail->path->utf8,'/',&size,buf);
#endif

  atom(file->utf8,0,&size,buf);
#endif

  return size;
}

///////////////////////////////////////////////////////////////////////////////
pb_path_t *pb_path_push(pb_path_t **head, pb_path_t **tail, pb_str_t *file)
{
  pb_path_t *p=NULL;
  int size;

  size=loop(NULL,*tail,file);

  if (NULL==(p=malloc(50+size)))
    return NULL;

  loop(p,*tail,file);

  if (NULL==(p->prev=*tail))
    *head=p;
    
  return *tail=p;
}

///////////////////////////////////////////////////////////////////////////////
void pb_path_pop(pb_path_t **head, pb_path_t **tail)
{
  pb_path_t *p=*tail;

  if (NULL==(*tail=p->prev))
    *head=NULL;

  free(p);
}
