/*
 * pb_trace.h
 *
 * Yet Another (WA)SAPI (YASAPI) New Technology (NT) Output (out_yasapi-nt)
 * Copyright (C) 2018  Peter Belkner (pbelkner@snafu.de)
 *
 * out_yasapi-nt is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * out_yasapi-nt is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with out_yasapi-nt.  If not, see <https://www.gnu.org/licenses/>.
 */
#ifndef __PB_TRACE_H__ // [
#define __PB_TRACE_H__

#include <pb.h>
#if defined (DEBUG) // [
#include <stdio.h>

#ifdef __cplusplus // [
extern "C" {
#endif // ]

int TraceCreate(void);
void TraceDestroy(void);

void TraceMarkLn(const char *pFile, int nLine, const char *pFunc);
void TraceWriteLn(const char *pFile, int nLine, const char *pFunc,
    const char *pLine);
void TraceWriteLnW(const char *pFile, int nLine, const char *pFunc,
    const wchar_t *pLine);
void TraceVWriteLn(const char *pFile, int nLine, const char *pFunc,
    const char *pFormat, ...);
void TraceVWriteLnW(const char *pFile, int nLine, const char *pFunc,
    const wchar_t *pFormat, ...);

#ifdef __cplusplus // [
}
#endif // ]
#endif // ]
#endif // __PB_TRACE_H__ ]
