#include <stdlib.h>
#include <stdarg.h>
#include "pb_xy.h"

void pb_x_init(pb_x_t *x)
{
  x->ps=NULL;
  x->n=0;
  pb_y_init(&x->y);
}

void pb_x_count(pb_x_t *x, TCHAR *ts, ...)
{
  va_list ap;
  int j,size;

  va_start(ap,ts);

  for (;ts;ts=va_arg(ap,TCHAR *))
	pb_y_count_part(&x->y,ts);

  va_end(ap);

  pb_y_count_whole(&x->y);
  ++x->n;
}

void pb_x_count_ps(pb_x_t *x, pb_str_t *ts, ...)
{
  va_list ap;
  int j,size;

  va_start(ap,ts);

  for (;ts;ts=va_arg(ap,pb_str_t *))
	pb_y_count_part_ps(&x->y,NULL,ts);

  va_end(ap);

  pb_y_count_whole(&x->y);
  ++x->n;
}

pb_str_t **pb_x_alloc(pb_x_t *x)
{
  int offs1,offs2;

  offs1=(x->n+1)*sizeof *x->ps;
  offs2=x->n*sizeof *x->buf;

  if (NULL==(x->ps=pb_y_alloc(&x->y,offs1+offs2)))
	return NULL;

  x->buf=(pb_str_t *)((char *)x->ps+offs1);
  x->n=0;

  return x->ps;
}

void pb_x_add(pb_x_t *x, TCHAR *ts, ...)
{
  va_list ap;
  int n;

  va_start(ap,ts);

  for (;ts;ts=va_arg(ap,TCHAR *))
	pb_y_add_part(&x->y,ts);

  va_end(ap);

  n=x->n;
  pb_y_add_whole(&x->y,x->buf+n);
  x->ps[n]=x->buf+n;
  ++x->n;
}

void pb_x_add_ps(pb_x_t *x, pb_str_t *ts, ...)
{
  va_list ap;
  int n;

  va_start(ap,ts);

  for (;ts;ts=va_arg(ap,pb_str_t *))
	pb_y_add_part_ps(&x->y,NULL,ts);

  va_end(ap);

  n=x->n;
  pb_y_add_whole(&x->y,x->buf+n);
  x->ps[n]=x->buf+n;
  ++x->n;
}

void pb_x_flush(pb_x_t *x)
{
  x->ps[x->n]=NULL;
}
